Before you continue please read this document.

Make sure that the following dependencies are installed on the target platform:
- Boost > 1.60
- LLVM > 3.6
- TCLAP
- CTemplate

Check out repositories:
https://git.rwth-aachen.de/CIM-XML-Interface/CIMRefactorer.git
https://git.rwth-aachen.de/CIM-XML-Interface/CIMUnmarshallingGenerator.git
https://git.rwth-aachen.de/CIM-XML-Interface/CIM-XML-Parser.git
https://git.rwth-aachen.de/CIM-XML-Interface/Refactoring-Script.git
https://git.rwth-aachen.de/CIM-XML-Interface/CIM-Include-Tool.git
Optional:
https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode.git

Initialize code submodule:
- cd CIM/
- git submodule update --init

Configure and build tools:
CIM Include Tool
- cd <CIM-Include-Tool>
- mkdir build
- cd build/
- cmake ..
- make

CIMRefactorer
- cd <CIMRefactorer>
- Configure makefile
  - Change paths according to your system
- make

CIMUnmarshallingGenerator
- cd <CIMUnmarshallingGenerator>
- Configure makefile
  - Change paths according to your system
- make


How to use the refactoring script to repair EA CIM code:
Refactoring Script
- Configure refactoring.sh
  - Change paths according to your system
- Run script ./refactoring.sh

To build the CIM C++ code change into the directory which contains the code and
execute the following commands:
- mkdir build
- cd build/
- cmake ..
- make

To generate the unmarshalling functions change into the build directory of the
CIMUnmarshallingGenerator and run the tool.
- cd .../CIMUnmarshallingGenerator/build/
- ./CIMUnmarshallingGenerator <GeneratedCodeDIR>

To build the CIM Parser copy the following files which will be generated by the
CIMUnmarshallingGenerator tool into the source directory of the CIM Parser:
- assignment.h/.cpp
- CIMFactory.h/.cpp
- task.h/.cpp

- Configure makefile
  - Change paths according to your system
- make
